Attribute VB_Name = "modProcs"
Option Explicit

'All credit for this code to Herman Liu from TrsnparentForm:
Public Sub changeFormEffect(F, inEffect As Integer)
    Dim W As Single, h As Single
    Dim edge As Single, topEdge As Single
    Dim mLeft, mTop
    Dim i As Integer
    Dim r As Long
    Dim outer As Long, inner As Long
    Dim mFormRegion As Long
    Dim ww As Single, hh As Single
    
    With F
        ' Put width/height in same denomination of scalewidth/scaleheight
        W = .ScaleX(.Width, vbTwips, vbPixels)
        h = .ScaleY(.Height, vbTwips, vbPixels)
        ww = .ScaleX(.ScaleWidth, vbTwips, vbPixels)
        hh = .ScaleY(.ScaleHeight, vbTwips, vbPixels)
        If inEffect = 0 Then
            mFormRegion = CreateRectRgn(0, 0, W, h)
            SetWindowRgn .hwnd, mFormRegion, True
            Exit Sub
        End If
        mFormRegion = CreateRectRgn(0, 0, 0, 0)
        ' Frame edges measurement
        edge = (W - ww) / 2
        topEdge = (h - edge - hh)
        ' Get frame
        If inEffect = 1 Then
            outer = CreateRectRgn(0, 0, W, h)
            inner = CreateRectRgn(0, topEdge, W, h)
            CombineRgn mFormRegion, outer, inner, RGN_DIFF
            ' caption
            outer = CreateRectRgn(0, 0, W, topEdge)
            inner = CreateRectRgn(edge, edge, W - edge, topEdge)
            CombineRgn mFormRegion, outer, inner, RGN_AND
        End If
        ' This error handling is necessary because of
        ' design-time only controls
        On Error Resume Next
        ' Combine regions of controls on form
        For i = 0 To .Controls.Count - 1
            If .Controls(i).Visible = True Then
                mLeft = .ScaleX(.Controls(i).Left, .ScaleMode, vbPixels) + edge
                mTop = .ScaleX(.Controls(i).Top, .ScaleMode, vbPixels) + topEdge
                r = CreateRectRgn(mLeft, mTop, _
                    mLeft + .ScaleX(.Controls(i).Width, .ScaleMode, vbPixels), _
                    mTop + .ScaleY(.Controls(i).Height, .ScaleMode, vbPixels))
                CombineRgn mFormRegion, r, mFormRegion, RGN_OR
            End If
        Next
    End With
    ' We allow toggle
    SetWindowRgn F.hwnd, mFormRegion, True
    DeleteObject mFormRegion
End Sub

Public Function LoadControl(oForm As Object, CtlType As String, CtlName As String) As Object
    Dim oCtl As Object
    'On Error Resume Next
    If IsObject(oForm.Controls) Then
        Set oCtl = oForm.Controls.Add(CtlType, CtlName)
        If Not oCtl Is Nothing Then
            Set LoadControl = oCtl
            Set oCtl = Nothing
        End If
    End If
End Function


